Using MQAI to list queues
Mills Perry
IT Consultant/Instructor, ZyQuest (USA)	c Xephon 2003



    Dim intConnectionHandle As Long, intCC As Long, intRC As Long
    ' Connect to the queue manager.
    MQCONN vData, intConnectionHandle, intCC, intRC


    Dim adminBag As Long    ' Admin bag handle.
    Dim systemBag As Long   ' System bag handle.
    Dim responseBag As Long ' Response bag handle.
    ' Initialize the bags.
    adminBag = MQHB_UNUSABLE_HBAG
    systemBag = MQHB_UNUSABLE_HBAG
    responseBag = MQHB_UNUSABLE_HBAG
    ' Create an admin bag.
    mqCreateBag MQCBO_ADMIN_BAG, adminBag, intCC, intRC
    ' Create a response bag.
    mqCreateBag MQCBO_ADMIN_BAG, responseBag, intCC, intRC


  ' Put generic local queue name into admin bag.
  mqAddString adminBag, MQCA_Q_NAME, MQBL_NULL_TERMINATED, "*", _
                intCC, intRC


  ' Send command to the queue manager.
  mqExecute intConnectionHandle, MQCMD_INQUIRE_Q, MQHB_NONE, adminBag, _
              responseBag, MQHO_NONE, MQHO_NONE, intCC, intRC


  ' Count how many system bags are embedded in the response bag.
  mqCountItems responseBag, MQHA_BAG_HANDLE, intQueueCount, _
               intCC, intRC
  For i = 0 To intQueueCount - 1
      ' Get the system bag handle.
      mqInquireBag responseBag, MQHA_BAG_HANDLE, i, systemBag, _
                   intCC, intRC    
      ' Get the queue name from the system bag.
      mqInquireString systemBag, MQCA_Q_NAME, 0, MQ_Q_NAME_LENGTH, 


      ' Do something with the queue name.
      MsgBox "Queue Name: " & strQName
  Next


  ' Clean up
  If adminBag > 0 Then _
      mqDeleteBag adminBag, intCC, intRC      
  If systemBag > 0 Then _
      mqDeleteBag systemBag, intCC, intRC     
  If responseBag > 0 Then _
      mqDeleteBag responseBag, intCC, intRC
  ' Disconnect the queue manager.  
  MQDISC intConnectionHandle, intCC, intRC


    ' Put local queue type into admin bag.
    mqAddInteger adminBag, MQIA_Q_TYPE, intTypeFilter, _
                 mvarCompletionCode, mvarReasonCode


  ' Add inquiry for current queue depths.
  mqAddInquiry adminBag, MQIA_CURRENT_Q_DEPTH, mvarCompletionCode, 


  ' Get the queue depth from the system bag.
  mqInquireInteger systemBag, MQIA_CURRENT_Q_DEPTH, MQIND_NONE, 


                   mvarCompletionCode, mvarReasonCode


  ' Add inquiry for queue types.
  mqAddInquiry adminBag, MQIA_Q_TYPE, mvarCompletionCode, mvarReasonCode


  ' Get the queue type from the system bag.
  mqInquireInteger systemBag, MQIA_Q_TYPE, MQIND_NONE, QType, _
                   mvarCompletionCode, mvarReasonCode


VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMQQueueList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "This class provides access to the list of queue names for a specified queue manager."
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'local variable(s) to hold property value(s)
Private mvarConnectionHandle    As Long
Private mvarCompletionCode      As Long
Private mvarReasonCode          As Long
Private mvarErrorMessage        As String
Private mvarQueueCount          As Long
Private mvarTypeFilter          As enmQueueType
Private mvarQMgrName            As String * 48
Public Enum enmQueueType
    qtAll = 0
    qtLocal = 1
    qtModel = 2
    qtAlias = 3
    qtRemote = 6
    qtCluster = 7
End Enum
' Private variables.
Private arQueue() As String
Private arType()  As String
Private arDepth() As Long
Private gbolDisconnect As Boolean
' MQSeries constants.
Const MQ_Q_MGR_NAME_LENGTH = 48
Const MQ_Q_NAME_LENGTH = 48
Const MQBL_NULL_TERMINATED = -1
Const MQCA_Q_NAME = 2016
Const MQCA_REMOTE_Q_NAME = 2018
Const MQCMD_INQUIRE_Q = 13
Const MQCBO_ADMIN_BAG = 1
Const MQCC_OK = 0
Const MQCC_WARNING = 1
Const MQCC_FAILED = 2
Const MQHA_BAG_HANDLE = 4001
Const MQHB_NONE = -2
Const MQHB_UNUSABLE_HBAG = -1
Const MQHO_NONE = 0
Const MQIA_Q_TYPE = 20
Const MQIA_CURRENT_Q_DEPTH = 3
Const MQIND_NONE = -1
Const MQQT_LOCAL = 1
Const MQQT_REMOTE = 6
' API Declarations.
Private Declare Sub mqCountItems Lib "MQIC32.DLL" Alias "mqCountItemsstd@20" (ByVal Bag As Long, ByVal Selector As Long, ItemCount As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqCreateBag Lib "MQIC32.DLL" Alias "mqCreateBagstd@16" (ByVal Options As Long, Bag As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqDeleteBag Lib "MQIC32.DLL" Alias "mqDeleteBagstd@12" (Bag As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqAddInquiry Lib "MQIC32.DLL" Alias "mqAddInquirystd@16" (ByVal Bag As Long, ByVal Selector As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqAddInteger Lib "MQIC32.DLL" Alias "mqAddIntegerstd@20" (ByVal Bag As Long, ByVal Selector As Long, ByVal ItemValue As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqAddString Lib "MQIC32.DLL" Alias "mqAddStringstd@24" (ByVal Bag As Long, ByVal Selector As Long, ByVal BufferLength As Long, ByVal Buffer As String, CompCode As Long, Reason As Long)
Private Declare Sub mqExecute Lib "MQIC32.DLL" Alias "mqExecutestd@36" (ByVal Hconn As Long, ByVal Command As Long, ByVal OptionsBag As Long, ByVal CommandBag As Long, ByVal responseBag As Long, ByVal CommandQ As Long, ByVal ResponseQ As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqInquireBag Lib "MQIC32.DLL" Alias "mqInquireBagstd@24" (ByVal Bag As Long, ByVal Selector As Long, ByVal ItemIndex As Long, ItemValue As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqInquireInteger Lib "MQIC32.DLL" Alias "mqInquireIntegerstd@24" (ByVal Bag As Long, ByVal Selector As Long, ByVal ItemIndex As Long, ItemValue As Long, CompCode As Long, Reason As Long)
Private Declare Sub mqInquireString Lib "MQIC32.DLL" Alias "mqInquireStringstd@36" (ByVal Bag As Long, ByVal Selector As Long, ByVal ItemIndex As Long, ByVal BufferLength As Long, ByVal Buffer As String, StringLength As Long, CodedCharSetId As Long, CompCode As Long, Reason As Long)
Private Declare Sub MQCONN Lib "MQIC32.DLL" Alias "MQCONNstd@16" (ByVal QMgrName As String, Hconn As Long, CompCode As Long, Reason As Long)
Private Declare Sub MQDISC Lib "MQIC32.DLL" Alias "MQDISCstd@12" (Hconn As Long, CompCode As Long, Reason As Long)
Public Sub LoadListControl(ByRef ListControl As Control)
    Dim i As Long
        If TypeOf ListControl Is ListBox _
    Or TypeOf ListControl Is ComboBox Then
        ListControl.Clear
        For i = 0 To QueueCount - 1
            ListControl.AddItem Queue(i)
        Next i
    End If
End Sub
Public Property Get QueueType(ByVal intIndex As Long) As String
    QueueType = arType(intIndex)
End Property
Public Property Let TypeFilter(ByVal vData As enmQueueType)
    mvarTypeFilter = vData
End Property

Public Property Get TypeFilter() As enmQueueType
    TypeFilter = mvarTypeFilter
End Property
Public Property Let QMgrName(ByVal vData As String)
    Dim intHandle As Long, intCC As Long, intRC As Long
    ' Connect to the queue manager.
    MQCONN vData, intHandle, intCC, intRC
    If intCC = MQCC_FAILED Then
        Err.Raise 10000, "clsMQQueueList", "Error " & intRC & " connecting to queue manager " & vData
    End If
    gbolDisconnect = True
    mvarQMgrName = vData
    ConnectionHandle = intHandle
End Property
Public Property Get QMgrName() As String
    QMgrName = mvarQMgrName
End Property
Public Property Get Depth(ByVal intIndex As Long) As Long
    Depth = arDepth(intIndex)
End Property
Public Property Let ConnectionHandle(ByVal vData As Long)
    Dim adminBag As Long    ' Admin bag handle.
    Dim systemBag As Long   ' System bag handle.
    Dim responseBag As Long ' Response bag handle.
    Dim intCompCode As Long, intReason As Long
    Dim i As Long, QType As enmQueueType
    Dim strQName As String * MQ_Q_NAME_LENGTH, intQNameLength As Long
    ' Update the property value.
    mvarConnectionHandle = vData
        ' Get the queue name list.
    adminBag = MQHB_UNUSABLE_HBAG
    systemBag = MQHB_UNUSABLE_HBAG
    responseBag = MQHB_UNUSABLE_HBAG    
    ' Create an admin bag.
    mqCreateBag MQCBO_ADMIN_BAG, adminBag, mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqCreateBag failure on admin bag."
        Exit Property
    End If    
    ' Create a response bag.
    mqCreateBag MQCBO_ADMIN_BAG, responseBag, mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqCreateBag failure on response bag."
        Exit Property
    End If    
    ' Put generic local queue name into admin bag.
    mqAddString adminBag, MQCA_Q_NAME, MQBL_NULL_TERMINATED, "*", mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqAddString failure."
        Exit Property
    End If    
    If mvarTypeFilter <> qtAll Then
        ' Put local queue type into admin bag.
        mqAddInteger adminBag, MQIA_Q_TYPE, mvarTypeFilter, mvarCompletionCode, mvarReasonCode
        If mvarCompletionCode = MQCC_FAILED Then
            mvarErrorMessage = "mqAddInteger failure."
            Exit Property
        End If
    End If    
    ' Add inquiry for current queue depths.
    mqAddInquiry adminBag, MQIA_CURRENT_Q_DEPTH, mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqAddInquiry failure for queue depth."
        Exit Property
    End If    
    ' Add inquiry for queue types.
    mqAddInquiry adminBag, MQIA_Q_TYPE, mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        MsgBox "mqAddInquiry failure for queue type.  RC=" & mvarReasonCode
        End
    End If    
    ' Send command to the queue manager.
    mqExecute mvarConnectionHandle, MQCMD_INQUIRE_Q, MQHB_NONE, adminBag, responseBag, MQHO_NONE, MQHO_NONE, _
              mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqExecute failure."
        Exit Property
    End If              
    ' Count number of system bags are embedded in the response bag.
    mqCountItems responseBag, MQHA_BAG_HANDLE, mvarQueueCount, mvarCompletionCode, mvarReasonCode
    If mvarCompletionCode = MQCC_FAILED Then
        mvarErrorMessage = "mqCountItems failure."
        Exit Property
    End If
        ReDim arQueue(mvarQueueCount)
    ReDim arType(mvarQueueCount)
    ReDim arDepth(mvarQueueCount)
    For i = 0 To mvarQueueCount - 1
        ' Get the system bag handle.
        mqInquireBag responseBag, MQHA_BAG_HANDLE, i, systemBag, mvarCompletionCode, mvarReasonCode
        If mvarCompletionCode = MQCC_FAILED Then
            mvarErrorMessage = "mqInquireBag failure."
            Exit Property
        End If    
        ' Get the queue name from the system bag.
        mqInquireString systemBag, MQCA_Q_NAME, 0, MQ_Q_NAME_LENGTH, strQName, _
                        intQNameLength, 0, mvarCompletionCode, mvarReasonCode
        If mvarCompletionCode = MQCC_FAILED Then
            mvarErrorMessage = "mqInquireString failure."
            Exit Property
        End If
                ' Get the queue type from the system bag.
        mqInquireInteger systemBag, MQIA_Q_TYPE, MQIND_NONE, QType, _
                         mvarCompletionCode, mvarReasonCode
        If mvarCompletionCode = MQCC_FAILED Then
            MsgBox "mqInquireInteger failure on queue type.  RC=" & mvarReasonCode
            End
        End If
                Select Case QType
            Case qtLocal:   arType(i) = "Local"
            Case qtModel:   arType(i) = "Model"
            Case qtAlias:   arType(i) = "Alias"
            Case qtRemote:  arType(i) = "Remote"
            Case qtCluster: arType(i) = "Cluster"
        End Select
                If QType = qtLocal Then
            ' Get the queue depth from the system bag.
            mqInquireInteger systemBag, MQIA_CURRENT_Q_DEPTH, MQIND_NONE, arDepth(i), _
                             mvarCompletionCode, mvarReasonCode
            If mvarCompletionCode = MQCC_FAILED Then
                mvarErrorMessage = "mqInquireInteger failure."
                Exit Property
            End If
        Else
            arDepth(i) = 0
        End If        
        arQueue(i) = Trim(strQName)
    Next i    
    ' Clean up
    If adminBag > 0 Then _
        mqDeleteBag adminBag, mvarCompletionCode, mvarReasonCode      ' Delete the admin bag.
    If systemBag > 0 Then _
        mqDeleteBag systemBag, mvarCompletionCode, mvarReasonCode     ' Delete the system bag.
    If responseBag > 0 Then _
        mqDeleteBag responseBag, mvarCompletionCode, mvarReasonCode   ' Delete the response bag.
End Property
Public Property Get ConnectionHandle() As Long
    ConnectionHandle = mvarConnectionHandle
End Property
Public Property Get Queue(ByVal intIndex As Long) As String
    Queue = arQueue(intIndex)
End Property
Public Property Get QueueCount() As Long
    QueueCount = mvarQueueCount
End Property
Public Property Get ErrorMessage() As String
    ErrorMessage = mvarErrorMessage
End Property
Public Property Get ReasonCode() As Long
    ReasonCode = mvarReasonCode
End Property
Public Property Get CompletionCode() As Long
    CompletionCode = mvarCompletionCode
End Property
Private Sub Class_Initialize()
End Sub
Private Sub Class_Terminate()
    Dim intCC As Long, intRC As Long    
    If gbolDisconnect Then MQDISC ConnectionHandle, intCC, intRC
End Sub


